/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "CrystalCPUIDDlg.h"
#include "DummyDlg.h"

#include "../common/DialogTemplateEx.h"

#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDApp

BEGIN_MESSAGE_MAP(CCrystalCPUIDApp, CWinApp)
	//{{AFX_MSG_MAP(CCrystalCPUIDApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDApp 

CCrystalCPUIDApp::CCrystalCPUIDApp()
{
}

/////////////////////////////////////////////////////////////////////////////

CCrystalCPUIDApp theApp;

int gLanguage = JAPANESE;
CBitmap gBackBitmap;
CBrush gBackBrush;
COLORREF gTextColor;
BOOL gFlagBack = FALSE;

int gDialogID = IDD_CRYSTALCPUID_DIALOG; // Default Dialog Templete

/////////////////////////////////////////////////////////////////////////////

BOOL CCrystalCPUIDApp::InitInstance()
{
	HANDLE hMutex = ::CreateMutex(NULL,FALSE,"CrystalCPUID");
	if (GetLastError()==ERROR_ALREADY_EXISTS){return FALSE;}
	
	// Set INI file place... 
	char aINIFile[MAX_PATH];
	char* ptrEnd;
	::GetModuleFileName(NULL, aINIFile, MAX_PATH);
	if ( (ptrEnd = strrchr(aINIFile, '.')) != NULL ) {
		*ptrEnd = '\0';
		strcat(aINIFile, ".ini");
		free((void*)m_pszProfileName);
		m_pszProfileName = strdup(aINIFile);
	}

	char str[256];
	GetPrivateProfileString("Setting","DialogStyle","",str,256,m_pszProfileName);
	if( ! strcmp(str,"24") ){
		gDialogID = IDD_CRYSTALCPUID_DIALOG_24;
	}
	if( ! strcmp(str,"26") ){
		gDialogID = IDD_CRYSTALCPUID_DIALOG_26;
	}

	// Select Dialog Templete
	for(int i=0; i<__argc; i++)
    {
		if( ! _stricmp(__argv[i],"-D24") || ! _stricmp(__argv[i],"/D24") ){
			gDialogID = IDD_CRYSTALCPUID_DIALOG_24;
		}
		if( ! _stricmp(__argv[i],"-D26") || ! _stricmp(__argv[i],"/D26") ){
			gDialogID = IDD_CRYSTALCPUID_DIALOG_26;
		}
    }

	// Multimedia Timer Setting
	TIMECAPS tc;
	timeGetDevCaps(&tc,sizeof(TIMECAPS));
	timeBeginPeriod(tc.wPeriodMin);

	AfxEnableControlContainer();

	ConnectSysInfo( MODE_PCI | MODE_DMI );

	CDummyDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

	DisconnectSysInfo();
/*
	CCrystalCPUIDDlg dlg;
	m_pMainWnd = &dlg;
	CDialogTemplateEx tml;
	tml.Load(MAKEINTRESOURCE(gDialogID));
	GetPrivateProfileString("Setting","FontFace","MS Sans Serif",str,256,m_pszProfileName);
	CString face = str;
	GetPrivateProfileString("Setting","FontSize","8",str,256,m_pszProfileName);
	USHORT size = atoi(str);
	if( size <= 0 ){size = 9;}
	tml.SetFont(face,size);
	dlg.InitModalIndirect((HGLOBAL)tml.Detach());
	dlg.DoModal();
*/
/*
	CCrystalCPUIDDlg *dlg;
	BOOL flag = FALSE;
	do{
		if( flag == TRUE ){
			delete dlg;
		}
		dlg = new CCrystalCPUIDDlg;
		if( flag == TRUE ){
			dlg->m_FlagShowCustomize = TRUE;
		}
		CDialogTemplateEx tml;
		tml.Load(MAKEINTRESOURCE(gDialogID));
		m_pMainWnd = dlg;
		GetPrivateProfileString("Setting","FontFace","MS Sans Serif",str,256,m_pszProfileName);
		CString face = str;
		GetPrivateProfileString("Setting","FontSize","8",str,256,m_pszProfileName);
		USHORT size = atoi(str);
		if( size <= 0 ){size = 9;}
		tml.SetFont(face,size);
		dlg->InitModalIndirect((HGLOBAL)tml.Detach());
		flag = TRUE;
	}while( dlg->DoModal() == 999 );
*/
/*	
	LOGFONT lf;
	CFontDialog FontDlg(&lf,CF_SCREENFONTS,NULL,NULL);
	if( FontDlg.DoModal() == IDOK ){
		CCrystalCPUIDDlg dlg;
		m_pMainWnd = &dlg;
		HDC hDC = GetDC(NULL);
		tml.SetFont(lf.lfFaceName,abs( lf.lfHeight * 72 / GetDeviceCaps(hDC, LOGPIXELSY) ));
		DeleteDC(hDC);
		dlg.InitModalIndirect((HGLOBAL)tml.Detach());
		
		if( dlg.DoModal() ){
			MessageBox(NULL,"","",MB_OK);
		}
	}
*/
/*
	CCrystalCPUIDDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();
*/
	timeEndPeriod(tc.wPeriodMin);

	::ReleaseMutex(hMutex);
	::CloseHandle(hMutex);
	
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// SysInfo.dll Load & Unload
/////////////////////////////////////////////////////////////////////////////

typedef ISysInfo* (*_CreateSysInfo) (DWORD);
typedef void (*_DestroySysInfo) (ISysInfo*);

BOOL CCrystalCPUIDApp::ConnectSysInfo(DWORD Mode)
{
	hSysInfoLib = LoadLibrary("SysInfo.dll");
	if(hSysInfoLib != NULL){
		_CreateSysInfo pCreateSysInfo = (_CreateSysInfo) GetProcAddress (hSysInfoLib,"CreateSysInfo");
		SysInfo = pCreateSysInfo(Mode);
		return TRUE;
	}else{
		MessageBox(NULL,"Not found \"SysInfo.dll\".","ERROR",MB_OK);
		exit(0);
		return FALSE;
	}
}

BOOL CCrystalCPUIDApp::DisconnectSysInfo()
{
	if(hSysInfoLib !=NULL){
		_DestroySysInfo pDestroySysInfo = (_DestroySysInfo) GetProcAddress (hSysInfoLib,"DestroySysInfo");
		pDestroySysInfo(SysInfo);
		FreeLibrary(hSysInfoLib);
		hSysInfoLib = NULL;
		SysInfo = NULL;
		return TRUE;
	}else{
		return FALSE;
	}
}